<html>

<head>

  <title>SVL</title>

  <meta http-equiv="content-type" content="text/html;charset=utf-8" />

  <style type="text/css">

    body
    {
      font-family: DejaVu Sans;
      font-size: 12px;
      margin: 0;
    }

    #container
    {
      margin: 20px;
      padding: 20px;
      background: red;
    }

    #console
    {
      overflow-x: hidden;
      overflow-y: scroll;
      background: black;
      color: white;
      font-family: DejaVu Sans Mono;
      font-size: 20px;
      font-weight: normal;
      width: 700px;
      height: 350px;
      white-space: pre;
      outline: none;
      border-style: solid;
      border-color: black;
      border-width: 0 0 0 3px;
    }

    #cursor
    {
      width: 12px;
      vertical-align: top;
    }

    #control
    {
      position: fixed;
      top: 0;
      right: 0;
    }

    #keyboard
    {
      margin-left: 20px;
    }

    input[type=text]
    {
      background: gold;
      border: 0;
      font-family: DejaVu Sans;
      color: black;
      font-size: 12px;
      margin: 0 2px 2px 0;
      padding: 0 2px;
      width: 40px;
      text-align: right;
    }

    div,
    label
    {
      display: inline-block;
    }

    .c
    {
      display: block;
      text-align: center;
      font-weight: bold;
      color: white;
      background: olive;
      width: 100%;
      margin: 0 0 2px 0;
    }

    .l
    {
      text-align: left;
    }

    .r
    {
      text-align: right;
    }

    label
    {
      width: 75px;
      margin: 0 5px;
    }

    label.event-type
    {
      width: 75px;
      text-align: left;
    }

    label.modifier,
    label.character,
    label.which,
    label.keycode,
    label.asc
    {
      text-align: center;
      margin: 0 2px 0 0;
    }

    label.modifier,
    input[type=text].modifier
    {
      width: 145px;
      text-align: center;
    }

    label.character,
    input[type=text].character
    {
      width: 105px;
      text-align: center;
    }

    label.which,
    input[type=text].which,
    label.keycode,
    input[type=text].keycode,
    label.asc,
    input[type=text].asc
    {
      width: 55px;
    }

    input[type=text].which,
    input[type=text].keycode,
    input[type=text].asc
    {
      padding-right: 17px;
    }

  </style>

  <script type="text/javascript">
  <!--


    var insert = true;


    var IE = document.all;

    /*
       <http://unixpapa.com/js/testkey.html>
       <http://www.ascii-code.com/>
    */

    var special_key =
    {
      /*
         Caracteres com o mesmo codigo ASCII no Firefox
            -  --  insert
            '  --  cursor right
            "  --  page down
            .  --  delete
      */
        8 : '<back space>',
        9 : '<tab>',
       13 : '<carriage return>',
       19 : '<pause>',
       20 : '<caps lock>',
       27 : '<escape>',
       32 : '<space>',
       33 : '<page up>',
       34 : '<page down>',
       35 : '<end>',
       36 : '<home>',
       37 : '<cursor left>',
       38 : '<cursor up>',
       39 : '<cursor right>',
       40 : '<cursor down>',
       45 : '<insert>',
       46 : '<delete>',
      144 : '<num lock>',
      145 : '<scroll lock>',
    };

    var function_key =
    {
      112 : '<f1>'  , // p
      113 : '<f2>'  , // q
      114 : '<f3>'  , // r
      115 : '<f4>'  , // s
      116 : '<f5>'  , // t
      117 : '<f6>'  , // u
      118 : '<f7>'  , // v
      119 : '<f8>'  , // w
      120 : '<f9>'  , // x
      121 : '<f10>' , // y
      122 : '<f11>' , // z
      123 : '<f12>' ,
    };

    var prompt, cont, tab, eol;
 // prompt = '❓'; // 2753
    prompt = '?'; // 2753
 // cont   = '➜'; // 279c
    cont   = '→'; // 2192
 // tab    = '⥤'; // 2964
    tab    = '⇥'; // 21e5
 // eol    = '↵'; // 21b5
    eol    = '↲'; // 21b2



    function $(elid)
    {
      return document.getElementById(elid);
    }



    function getSelectionStatus(el)
    {
      var start = end = line = col = lines = cols = 0;
      var normalizedValue, range, textInputRange, len, endRange, lines_set;
      if ( typeof el.selectionStart == 'number' && typeof el.selectionEnd == 'number' )
      {
        start = el.selectionStart;
        end   = el.selectionEnd;
      }
      else
      {
        range = document.selection.createRange();
        if ( range && range.parentElement() == el )
        {
          len = el.value.length;
          normalizedValue = el.value.replace(/\r\n/g, '\n');
          // Create a working TextRange that lives only in the input
          textInputRange = el.createTextRange();
          textInputRange.moveToBookmark(range.getBookmark());
          // Check if the start and end of the selection are at the very end
          // of the input, since moveStart/moveEnd doesn't return what we want
          // in those cases
          endRange = el.createTextRange();
          endRange.collapse(false);
          if ( textInputRange.compareEndPoints('StartToEnd', endRange) > -1 )
          {
              start = end = len;
          }
          else
          {
            start  = -textInputRange.moveStart('character', -len);
            start += normalizedValue.slice(0, start).split('\n').length - 1;
            if ( textInputRange.compareEndPoints('EndToEnd', endRange) > -1 )
            {
              end  = len;
            }
            else
            {
              end  = -textInputRange.moveEnd('character', -len);
              end += normalizedValue.slice(0, end).split('\n').length - 1;
            }
          }
        }
      }
      set1  = el.value.split('\n');
      lines = set1.length;
      set2  = el.value.substr(0,start).split('\n');
      line  = set2.length - 1;
      col   = set2[line].length;
      cols  = set1[line].length;
      return {
               'start' : start,
               'end'   : end,
               'line'  : line,
               'col'   : col,
               'lines' : lines,
               'cols'  : cols
             };
    }



    function set_cursor_pos(ctrl, pos)
    {
      if (ctrl.setSelectionRange)
      {
        ctrl.focus();
        ctrl.setSelectionRange(pos,pos);
      }
      else
      {
        if (ctrl.createTextRange)
        {
          range = ctrl.createTextRange();
          range.collapse(true);
          range.moveEnd('character', pos);
          range.moveStart('character', pos);
          range.select();
        }
      }
    }



    function show(data)
    {
      for(field in data) $(field).value = data[field];
    }



    function readKey(type,ev)
    {

      // <http://unixpapa.com/js/testkey.html>
      // <http://www.ascii-code.com/>

      var eparts = [ 'modifier', 'character', 'which', 'keycode', 'asc' ];
      var key    = new Array();

      key['modifier'] = '';
      if ( ev.ctrlKey  ) key['modifier'] += '<control>';
      if ( ev.altKey   ) key['modifier'] += '<alternate>';
      if ( ev.shiftKey ) key['modifier'] += '<shift>';
      if ( ev.metaKey  ) key['modifier'] += '<meta>';

      key['which'  ] = ev.which;
      key['keycode'] = ev.keyCode;
      key['asc'    ] = key['keycode']==0 ? key['which'] : key['keycode'];

      key['character'] = String.fromCharCode(key['asc']);
      if ( special_key[key['asc']] !== undefined ) key['character'] = special_key[key['asc']];
      if ( key['keycode']!=0 && function_key[key['asc']] !== undefined ) key['character'] = function_key[key['asc']];

      for (epart in eparts) $(type+'-'+eparts[epart]).value = key[eparts[epart]];
   // $('lastKey').value = $('console').lastKey;

    }



    function interpret(el,ev)
    {

/*

      var blast, last;
      var asc, chr;
      var col, cols;

      var data = getSelectionStatus(el);

      blast = el.value.substr(-2,1);
      last  = el.value.substr(-1,1);
      asc   = $('keypress-asc').value;
      chr   = $('keypress-character').value;
      col   = data['col'];
      cols  = data['cols'];
      pos   = data['start'];

      if (last=='\n') last = '<cr>';

      data['blast'] = blast;
      data['last' ] =  last;

      if (asc==13     && last=='<cr>') el.value = el.value.substr(0,el.value.length-1)+eol+'\n'+prompt+' ';
      if (col==40     && chr!='<cursor left>' && chr!='<cursor right>' && chr!='<back space>') el.value += cont+'\n';

      if (col==2      && chr=='<cursor left>') el.value += eol+'\n';
      if (col==2      && chr=='<back space>' ) el.value += eol+'\n';

      if (col==cols   && chr!='<cursor left>' && chr!='<cursor right>') el.value += eol+'\n';
      if (col==cols+1 && chr=='<cursor left>' ) set_cursor_pos($('console'), pos-2);
      if (col==cols   && chr=='<cursor right>') set_cursor_pos($('console'), pos+2);
      $('console').scrollTop = $('console').scrollHeight - $('console').clientHeight;

      show(data);

      if ( $('keydown-character').value==='<cursor down>' ) el.scrollTop -= 24;
      if ( $('keydown-character').value==='<insert>' )
      {
        $('insert').value = $('insert').value==='false';
        insert();
      }

*/

    }



    function bodyPosition(ev)
    {

      $('screen-width'      ).value = screen.width;
      $('screen-height'     ).value = screen.height;
      $('screen-availWidth' ).value = screen.availWidth;
      $('screen-availHeight').value = screen.availHeight;

      $('window-outerWidth' ).value = window.outerWidth;
      $('window-outerHeight').value = window.outerHeight;
      $('window-innerWidth' ).value = window.innerWidth;
      $('window-innerHeight').value = window.innerHeight;
      $('window-pageXOffset').value = window.pageXOffset;
      $('window-pageYOffset').value = window.pageYOffset;

      $('body-scrollLeft'   ).value = document.body.scrollLeft;
      $('body-scrollTop'    ).value = document.body.scrollTop;
      $('body-clientWidth'  ).value = document.body.clientWidth;
      $('body-clientHeight' ).value = document.body.clientHeight;
      $('body-scrollWidth'  ).value = document.body.scrollWidth;
      $('body-scrollHeight' ).value = document.body.scrollHeight;
      $('body-offsetLeft'   ).value = document.body.offsetLeft;
      $('body-offsetTop'    ).value = document.body.offsetTop;
      $('body-clientX'      ).value = ev.clientX;
      $('body-clientY'      ).value = ev.clientY;

    }



    function mousePosition(el,ev)
    {

      if (ev==null) ev = window.event;
      var id = el.id;
      $(id+'-scrollLeft'  ).value = el.scrollLeft;
      $(id+'-scrollTop'   ).value = el.scrollTop;
      $(id+'-clientWidth' ).value = el.clientWidth;
      $(id+'-clientHeight').value = el.clientHeight;
      $(id+'-scrollWidth' ).value = el.scrollWidth;
      $(id+'-scrollHeight').value = el.scrollHeight;
      $(id+'-offsetLeft'  ).value = el.offsetLeft;
      $(id+'-offsetTop'   ).value = el.offsetTop;
      $(id+'-clientX'     ).value = ev.clientX;
      $(id+'-clientY'     ).value = ev.clientY;

/*

      var obj  = el;
      var ell  = obj.offsetLeft;
      var elt  = obj.offsetTop;
      var body = document.getElementsByTagName('body')[0];
      while (obj.offsetParent && obj!=body)
      {
        ell -= obj.offsetLeft;
        elt -= obj.offsetTop;
        obj  = obj.offsetParent;
      }
      $('consolel').value = ell;
      $('consolet').value = elt;
      $('consolew').value = $(el.id).style.width;
      $('consoleh').value = $(el.id).style.height;

*/

    }



   function captureTab(ev)
   {
  // if ($('keydown-character').value=='<tab>') setTimeout("$('console').focus()",1);
     if ( ev.which==40 ) setTimeout("$('console').focus()",1);
   }



   function setCursor(state,ev)
   {
     $('cursor').src = 'cursor-'+state+'.gif';
  // if ($('keydown-character').value=='<tab>') setTimeout("$('console').focus()",1);
      if ( ev.which==40 ) setTimeout("$('console').focus()",1);
     doinsert();
   }



   function doinsert()
   {
  // $('cursor').style.height        = ( $('insert').value==='true' ? 24 : 3 ) + 'px';
  // $('cursor').style.verticalAlign =   $('insert').value==='true' ? 'top' : 'bottom';
     $('cursor').style.height        = ( insert ? 24 : 3 ) + 'px';
     $('cursor').style.verticalAlign =   insert ? 'top' : 'bottom';
   }



   function capLock(e)
   {
     var kc = e.keyCode  ? e.keyCode  : e.which;
     var sk = e.shiftKey ? e.shiftKey : ( (kc==16) ? true : false );
     $('divMayus').style.visibility = ( (kc>=65 && kc<=90) && !sk) || ( (kc>=97 && kc<=122) && sk) ? 'visible' : 'hidden';
   }



    function keyPress(el,ev)
    {
    }



    function keyDown(el,ev)
    {
      if ( ev.which==40 ) el.scrollTop -= 24;
      if ( ev.which==45 )
      {
        insert = ! insert;
        $('insert').value = insert;
        doinsert();
      }
    }



    function keyUp(el,ev)
    {
    }



    function textInput(el,ev)
    {
    }



   function init(ev)
   {
     $(   'console').focus();
     $(    'insert').value = 'true';
     $(   'numlock').value = 'false';
     $(  'capslock').value = 'false';
     $('scrolllock').value = 'false';
     setCursor('focus',ev);
   }



  //-->
  </script>

</head>

<body
 onload      = "init(event)"
 onmousemove = "bodyPosition(event)"
>

  <div
   id      = "container"
   onclick = "mousePosition(this,event)"
  >

  <div
   id              = "console"
   tabindex        = "0"
   contenteditable = "false"
   onkeypress      = "readKey('keypress' ,event); keyPress (this,event); interpret(this,event);"
   onkeydown       = "readKey('keydown'  ,event); keyDown  (this,event); interpret(this,event);"
   onkeyup         = "readKey('keyup'    ,event); keyUp    (this,event); interpret(this,event);"
   ontextinput     = "readKey('textinput',event); textInput(this,event); interpret(this,event);"
   onclick         = "mousePosition(this ,event);"
   onblur          = "setCursor('blur',event);captureTab();"
   onfocus         = "setCursor('focus');"
  >SVG Logo 0.3
Bem-vindo ao Logo

? TESTEfÁ<img src="" id="cursor" />jp

  abcdefghijklmnopqrstuvwxyz
  ABCDEFGHIJKLMNOPQRSTUVWXYZ
  0123456789
  cÇáÁ


























</div>

</div>

  <div id="control">

    <label class="c">screen</label>
    <label class="r">width      </label><input type="text" id="screen-width"          readonly="true" /><input type="text" id="screen-height"          readonly="true" /><label class="l">height      </label><br />
    <label class="r">availWidth </label><input type="text" id="screen-availWidth"     readonly="true" /><input type="text" id="screen-availHeight"     readonly="true" /><label class="l">availHeight </label><br />
    <br />
    <label class="c">window</label>
    <label class="r">outerWidth </label><input type="text" id="window-outerWidth"     readonly="true" /><input type="text" id="window-outerHeight"     readonly="true" /><label class="l">outerHeight </label><br />
    <label class="r">innerWidth </label><input type="text" id="window-innerWidth"     readonly="true" /><input type="text" id="window-innerHeight"     readonly="true" /><label class="l">innerHeight </label><br />
    <label class="r">pageXOffset</label><input type="text" id="window-pageXOffset"    readonly="true" /><input type="text" id="window-pageYOffset"     readonly="true" /><label class="l">pageYOffset </label><br />
    <br />
    <label class="c">body</label>
    <label class="r">scrollLeft </label><input type="text" id="body-scrollLeft"       readonly="true" /><input type="text" id="body-scrollTop"         readonly="true" /><label class="l">scrollTop   </label><br />
    <label class="r">clientWidth</label><input type="text" id="body-clientWidth"      readonly="true" /><input type="text" id="body-clientHeight"      readonly="true" /><label class="l">clientHeight</label><br />
    <label class="r">scrollWidth</label><input type="text" id="body-scrollWidth"      readonly="true" /><input type="text" id="body-scrollHeight"      readonly="true" /><label class="l">scrollHeight</label><br />
    <label class="r">offsetLeft </label><input type="text" id="body-offsetLeft"       readonly="true" /><input type="text" id="body-offsetTop"         readonly="true" /><label class="l">offsetTop   </label><br />
    <label class="r">clientX    </label><input type="text" id="body-clientX"          readonly="true" /><input type="text" id="body-clientY"           readonly="true" /><label class="l">clientY     </label><br />
    <br />
    <label class="c">#container</label>
    <label class="r">scrollLeft </label><input type="text" id="container-scrollLeft"  readonly="true" /><input type="text" id="container-scrollTop"    readonly="true" /><label class="l">scrollTop   </label><br />
    <label class="r">clientWidth</label><input type="text" id="container-clientWidth" readonly="true" /><input type="text" id="container-clientHeight" readonly="true" /><label class="l">clientHeight</label><br />
    <label class="r">scrollWidth</label><input type="text" id="container-scrollWidth" readonly="true" /><input type="text" id="container-scrollHeight" readonly="true" /><label class="l">scrollHeight</label><br />
    <label class="r">offsetLeft </label><input type="text" id="container-offsetLeft"  readonly="true" /><input type="text" id="container-offsetTop"    readonly="true" /><label class="l">offsetTop   </label><br />
    <label class="r">clientX    </label><input type="text" id="container-clientX"     readonly="true" /><input type="text" id="container-clientY"      readonly="true" /><label class="l">clientY     </label><br />
    <br />
    <label class="c">#console</label>
    <label class="r">scrollLeft </label><input type="text" id="console-scrollLeft"    readonly="true" /><input type="text" id="console-scrollTop"      readonly="true" /><label class="l">scrollTop   </label><br />
    <label class="r">clientWidth</label><input type="text" id="console-clientWidth"   readonly="true" /><input type="text" id="console-clientHeight"   readonly="true" /><label class="l">clientHeight</label><br />
    <label class="r">scrollWidth</label><input type="text" id="console-scrollWidth"   readonly="true" /><input type="text" id="console-scrollHeight"   readonly="true" /><label class="l">scrollHeight</label><br />
    <label class="r">offsetLeft </label><input type="text" id="console-offsetLeft"    readonly="true" /><input type="text" id="console-offsetTop"      readonly="true" /><label class="l">offsetTop   </label><br />
    <label class="r">clientX    </label><input type="text" id="console-clientX"       readonly="true" /><input type="text" id="console-clientY"        readonly="true" /><label class="l">clientY     </label><br />

    <br />

    <label class="r">Line       </label><input type="text" id="line"                  readonly="true" /><input type="text" id="column"                 readonly="true" /><label class="l">Column      </label><br />
    <label class="r">Lines      </label><input type="text" id="lines"                 readonly="true" /><input type="text" id="columns"                readonly="true" /><label class="l">Columns     </label>

  </div>

  <div id="keyboard">

    <label>    Insert</label><input type="text" id=    "insert" readonly="true" /><br />
    <label>   NumLock</label><input type="text" id=   "numlock" readonly="true" /><br />
    <label>  CapsLock</label><input type="text" id=  "capslock" readonly="true" /><br />
    <label>ScrollLock</label><input type="text" id="scrolllock" readonly="true" /><br />
    <br />
    <label class="event-type">           </label><label class="modifier">Modifier</label                                      ><label class="character">Character</label                               ><label class="which">Which</label                               ><label class="keycode">KeyCode</label                               ><label class="asc">ASC</label><br />
    <label class="event-type">onKeyPress </label><input class="modifier" type="text" id="keypress-modifier"  readonly="true" /><input class="character" type="text" id="keypress-character"  readonly /><input class="which" type="text" id="keypress-which"  readonly /><input class="keycode" type="text" id="keypress-keycode"  readonly /><input class="asc" type="text" id="keypress-asc"  readonly /><br />
    <label class="event-type">onKeyDown  </label><input class="modifier" type="text" id="keydown-modifier"   readonly="true" /><input class="character" type="text" id="keydown-character"   readonly /><input class="which" type="text" id="keydown-which"   readonly /><input class="keycode" type="text" id="keydown-keycode"   readonly /><input class="asc" type="text" id="keydown-asc"   readonly /><br />
    <label class="event-type">onKeyUp    </label><input class="modifier" type="text" id="keyup-modifier"     readonly="true" /><input class="character" type="text" id="keyup-character"     readonly /><input class="which" type="text" id="keyup-which"     readonly /><input class="keycode" type="text" id="keyup-keycode"     readonly /><input class="asc" type="text" id="keyup-asc"     readonly /><br />
    <label class="event-type">onTextInput</label><input class="modifier" type="text" id="textinput-modifier" readonly="true" /><input class="character" type="text" id="textinput-character" readonly /><input class="which" type="text" id="textinput-which" readonly /><input class="keycode" type="text" id="textinput-keycode" readonly /><input class="asc" type="text" id="textinput-asc" readonly /><br />
    <br />
    <label>Penúltimo </label><input type="text" id="blast"      readonly="true" /><br />
    <label>Último    </label><input type="text" id="last"       readonly="true" /><br />
    <label>lastKey   </label><input type="text" id="lastKey"    readonly="true" /><br />

  </div>

  <br />
  <br />
  <br />
  <br />
  <br />
  <br />
  <br />
  <br />
  <br />
  <br />
  <br />
  <br />
  <br />

</body>

</html>
